import java.net.ServerSocket;
import java.net.Socket;

import java.io.DataInputStream;
import java.io.DataOutputStream;

import java.io.IOException;

public class StreamServer implements Runnable{
  
  public static void main (String [] args) {
    Thread t = new Thread(new StreamServer());
    t.setPriority(4);
    t.start();
  }
  
  public void run() {
    try {
      System.out.println("Initializing");
      ServerSocket serv = new ServerSocket(2512);
      System.out.println("Server listening on port 2512");
      while (true) {
        Socket client = serv.accept();
        System.out.println("new Client from: "+client);
        new StreamClientThread(client).start();
      }
    } catch (IOException e) {
      System.err.println(e);
    }
  }
  
}

class StreamClientThread extends Thread {
  
  DataOutputStream dos;
  DataInputStream dis;
  Socket client;
  
  StreamClientThread (Socket client) {
    this.client=client;
    try {
      dis = new DataInputStream(client.getInputStream());    
      dos = new DataOutputStream(client.getOutputStream());
    } catch (IOException iox) {
      System.err.println(iox);
    }
  }
  
  public void run() {
    while (true) {
      try {
        int i1=dis.readInt();
        System.out.println("> "+client+" got "+i1);
        int i2=dis.readInt();
        System.out.println("> "+client+" got "+i2);
        System.out.println("< "+client+" writing "+i1*i2);
        dos.writeUTF("" + i1*i2);
        dos.flush();
      } catch (IOException e) {
        System.err.println(e);
        stop();
      }
    }
  }
}
  
